Unit asg8e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AFG4E_p, UTAFSI_p;

procedure asg8e(var A :Array of Extended; M :Integer;
                N :Integer; var NLEAD :Array of Integer;
                var B :Array of Extended; LTR :Integer; L :Integer;
                var RCOND :Extended; var X :Array of Extended;
                var IERR :Integer);

implementation

procedure asg8e(var A :Array of Extended; M :Integer;
                N :Integer; var NLEAD :Array of Integer;
                var B :Array of Extended; LTR :Integer; L :Integer;
                var RCOND :Extended; var X :Array of Extended;
                var IERR :Integer);
var
I,J,JJ,K,KB,KP1,NM1 :Integer;
S,T :Extended;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230,_240,_250,_260,_270,_280,_290,
_300,_310,_320,_330,_340,_350,_360,_370;
begin
{ ***************************************************C }
{   PEEHE CCTEM A*X=B  TRANS(A)*X=B METOOM   C }
{   AYCCA C BOPOM BEYEO EMEHA O CTOY     C }
{    OEHKA CA OYCOBEHHOCT MATP A.        C }
{ ***************************************************C }
RCOND  := 0.0e0;

{   YCTAHOBEHE KOHTPO HA BOMOHOCT EPEOHEH }
S  := 0.0e0;
_10:

{   POBEPKA PABHOCT AAH APAMETPOB M  N }
if ( N  >=  1 ) and (  M  >=  1 ) 
 then goto _20;
IERR  := 65;
UTAFSI('A','S','G','8','E',IERR);
goto _370;
_20:
IERR  := 0;
NM1  := N - 1;
if ( L  <>  0 ) 
 then goto _30;
AFG4E(A,M,N,NLEAD,RCOND,X,IERR);
if ( IERR  <>  0 ) 
 then UTAFSI('A','S','G','8','E',IERR);
if ( IERR  <=  0 ) 
 then goto _30;
goto _370;
_30:
I  := ((N) Mod (7));
if ( I  =  0 ) 
 then goto _50;
for JJ:=1 to I do
 begin
  X[JJ-1] := B[JJ-1];
_40:
 end;
_50:
I  := I + 1;
if ( I  >  N ) 
 then goto _70;
JJ := I;
while ( JJ<=N ) do
 begin
  X[JJ-1] := B[JJ-1];
  X[JJ+0] := B[JJ+0];
  X[JJ+1] := B[JJ+1];
  X[JJ+2] := B[JJ+2];
  X[JJ+3] := B[JJ+3];
  X[JJ+4] := B[JJ+4];
  X[JJ+5] := B[JJ+5];
_60:
  inc(JJ,7);
 end;
_70:
if ( LTR  <>  0 ) 
 then goto _230;

{   PEEHE CCTEM L*Y=B }
if ( NM1  <  1 ) 
 then goto _140;
for K:=1 to NM1 do
 begin
  JJ  := NLEAD[K-1];
  T  := X[JJ-1];
  if ( JJ  =  K ) 
   then goto _80;
  X[JJ-1] := X[K-1];
  X[K-1] := T;
_80:
  JJ  := N - K;
  I  := ((JJ) Mod (4)) + K;
  if ( I  =  K ) 
   then goto _100;
  KP1  := K + 1;
  for JJ:=KP1 to I do
   begin
    X[JJ-1] := X[JJ-1] + T*A[(JJ-1)+(K-1)*M];
_90:
   end;
_100:
  I  := I + 1;
  if ( I  >  N ) 
   then goto _120;
  JJ := I;
  while ( JJ<=N ) do
   begin
    X[JJ-1] := X[JJ-1] + T*A[(JJ-1)+(K-1)*M];
    X[JJ+0] := X[JJ+0] + T*A[(JJ+0)+(K-1)*M];
    X[JJ+1] := X[JJ+1] + T*A[(JJ+1)+(K-1)*M];
    X[JJ+2] := X[JJ+2] + T*A[(JJ+2)+(K-1)*M];
_110:
    inc(JJ,4);
   end;
_120:
_130:
 end;
_140:

{   PEEHE CCTEM U*X=Y }
for KB:=1 to N do
 begin
  K  := N + 1 - KB;
  if ( A[(K-1)+(K-1)*M] <>  0.0e0 ) 
   then goto _160;
  if ( X[K-1] <>  0.0e0 ) 
   then goto _150;
  X[K-1] := 1.0e0;
  goto _170;
_150:
  IERR  := 67;
  UTAFSI('A','S','G','8','E',IERR);
  goto _370;
_160:
  X[K-1] := X[K-1]/A[(K-1)+(K-1)*M];
_170:
  T  := X[K-1];
  J  := K - 1;
  I  := ((J) Mod (4));
  if ( I  =  0 ) 
   then goto _190;
  for JJ:=1 to I do
   begin
    X[JJ-1] := X[JJ-1] - T*A[(JJ-1)+(K-1)*M];
_180:
   end;
_190:
  I  := I + 1;
  if ( I  >  J ) 
   then goto _210;
  JJ := I;
  while ( JJ<=J ) do
   begin
    X[JJ-1] := X[JJ-1] - T*A[(JJ-1)+(K-1)*M];
    X[JJ+0] := X[JJ+0] - T*A[(JJ+0)+(K-1)*M];
    X[JJ+1] := X[JJ+1] - T*A[(JJ+1)+(K-1)*M];
    X[JJ+2] := X[JJ+2] - T*A[(JJ+2)+(K-1)*M];
_200:
    inc(JJ,4);
   end;
_210:
_220:
 end;
goto _370;

{   PEEHE CCTEM TRANS(U)*Y=B }
_230:
for K:=1 to N do
 begin
  T  := 0.0e0;
  J  := K - 1;
  I  := ((J) Mod (5));
  if ( I  =  0 ) 
   then goto _250;
  for JJ:=1 to I do
   begin
    T  := T + A[(JJ-1)+(K-1)*M]*X[JJ-1];
_240:
   end;
_250:
  I  := I + 1;
  if ( I  >  J ) 
   then goto _270;
  JJ := I;
  while ( JJ<=J ) do
   begin
    T  := T + A[(JJ-1)+(K-1)*M]*X[JJ-1] + A[(JJ+0)+(K-1)*M]*X[JJ+0] + A[(JJ+2-1)+(
    K-1)*M]*X[JJ+1] + A[(JJ+2)+(K-1)*M]*X[JJ+2] + A[(JJ+3)+(K-1)*M]*
    X[JJ+3];
_260:
    inc(JJ,5);
   end;
_270:
  if ( A[(K-1)+(K-1)*M] <>  0.0e0 ) 
   then goto _290;
  if ( X[K-1] - T  <>  0.0e0 ) 
   then goto _280;
  X[K-1] := 1.0e0;
  goto _300;
_280:
  IERR  := 67;
  UTAFSI('A','S','G','8','E',IERR);
  goto _370;
_290:
  X[K-1] := (X[K-1] - T)/A[(K-1)+(K-1)*M];
_300:
 end;

{   PEEHE CCTEM TRANS(L)*X=Y }
if ( NM1  <  1 ) 
 then goto _370;
for KB:=1 to NM1 do
 begin
  K  := N - KB;
  JJ  := N - K;
  I  := ((JJ) Mod (5)) + K;
  if ( I  =  K ) 
   then goto _320;
  KP1  := K + 1;
  for JJ:=KP1 to I do
   begin
    X[K-1] := X[K-1] + A[(JJ-1)+(K-1)*M]*X[JJ-1];
_310:
   end;
_320:
  I  := I + 1;
  if ( I  >  N ) 
   then goto _340;
  JJ := I;
  while ( JJ<=N ) do
   begin
    X[K-1] := X[K-1] + A[(JJ-1)+(K-1)*M]*X[JJ-1] + A[(JJ+0)+(K-1)*M]*X[JJ+0]
    + A[(JJ+1)+(K-1)*M]*X[JJ+1] + A[(JJ+2)+(K-1)*M]*X[JJ+2]
    + A[(JJ+3)+(K-1)*M]*X[JJ+3];
_330:
    inc(JJ,5);
   end;
_340:
  JJ  := NLEAD[K-1];
  if ( JJ  =  K ) 
   then goto _350;
  T  := X[JJ-1];
  X[JJ-1] := X[K-1];
  X[K-1] := T;
_350:
_360:
 end;
_370:
end;

end.
